<div class="example-container mat-elevation-z8">
  <table mat-table [dataSource]="dataSource">
    <!-- * Filter * -->
    <ng-container matColumnDef="filter">
      <th mat-header-cell *matHeaderCellDef colspan="5">
        <mat-form-field appearance="standard">
          <mat-label>Filter</mat-label>
          <input
            matInput
            (keyup)="applyFilter($event)"
            placeholder="Ex. Coffee, Bread, Juice"
            #input
          />
        </mat-form-field>
      </th>
    </ng-container>

    <!-- Position Column -->
    <ng-container matColumnDef="position">
      <th mat-header-cell *matHeaderCellDef>No.</th>
      <td mat-cell *matCellDef="let discount">
        {{ dataSource.data.indexOf(discount) + 1 }}
      </td>
    </ng-container>

    <!-- Item A name Column -->
    <ng-container matColumnDef="itemNameA">
      <th mat-header-cell *matHeaderCellDef>1° Item</th>
      <td mat-cell *matCellDef="let discount">
        <ng-container *ngIf="isEdit(editMode, discount); else elseTemplate">
          <mat-form-field appearance="outline">
            <input matInput type="text" [formControl]="itemNameA" />
          </mat-form-field>
        </ng-container>
        <ng-template #elseTemplate>
          {{ discount?.itemNameA }}
        </ng-template>
      </td>
    </ng-container>

    <!-- Item B name Column -->

    <ng-container matColumnDef="itemNameB">
      <th mat-header-cell *matHeaderCellDef>2° Item</th>
      <td mat-cell *matCellDef="let discount">
        <ng-container *ngIf="isEdit(editMode, discount); else elseTemplate">
          <mat-form-field appearance="outline">
            <input matInput type="text" [formControl]="itemNameB" />
          </mat-form-field>
        </ng-container>
        <ng-template #elseTemplate>
          {{ discount?.itemNameB }}
        </ng-template>
      </td>
    </ng-container>

    <!-- Discount Column -->
    <ng-container matColumnDef="value">
      <th mat-header-cell *matHeaderCellDef>Discount (%)</th>
      <td mat-cell *matCellDef="let discount">
        <ng-container *ngIf="isEdit(editMode, discount); else elseTemplate">
          <mat-form-field appearance="outline">
            <input matInput type="number" [formControl]="value"
          /></mat-form-field>
        </ng-container>
        <ng-template #elseTemplate> {{ discount?.value }} % </ng-template>
      </td>
    </ng-container>
    <!-- Action Column -->
    <ng-container matColumnDef="action">
      <th mat-header-cell *matHeaderCellDef>Actions</th>
      <td mat-cell *matCellDef="let discount">
        <ng-container *ngIf="isEdit(editMode, discount); else elseTemplate">
          <button
            mat-icon-button
            color="primary"
            [disabled]="!form.valid"
            (click)="
              onEditDiscount(discount);
              toggleEdit(dataSource.data.indexOf(discount), discount)
            "
          >
            <mat-icon>check</mat-icon>
          </button>

          <button
            mat-icon-button
            color="primary"
            (click)="toggleEdit(dataSource.data.indexOf(discount), discount)"
          >
            <mat-icon>cancel</mat-icon>
          </button>
        </ng-container>
        <ng-template #elseTemplate>
          <button
            mat-icon-button
            color="primary"
            (click)="toggleEdit(dataSource.data.indexOf(discount), discount)"
          >
            <mat-icon>edit</mat-icon>
          </button>
          <button
            mat-icon-button
            color="warn"
            (click)="onDeleteDiscount(discount)"
          >
            <mat-icon>delete</mat-icon>
          </button>
        </ng-template>
      </td>
    </ng-container>

    <!-- * Paginator * -->
    <ng-container matColumnDef="paginator">
      <td mat-footer-cell *matFooterCellDef colspan="5">
        <mat-paginator [pageSizeOptions]="[10, 25, 100]"></mat-paginator>
      </td>
    </ng-container>

    <!-- **Headers** -->
    <tr mat-header-row *matHeaderRowDef="['filter']"></tr>
    <tr mat-header-row *matHeaderRowDef="displayedColumns; sticky: true"></tr>

    <!-- **Rows** -->
    <tr mat-row *matRowDef="let row; columns: displayedColumns"></tr>
    <!-- Row shown when there is no matching data. -->
    <tr class="mat-row" *matNoDataRow>
      <td class="mat-cell" colspan="5">No data matching the filter</td>
    </tr>

    <!-- **Footers** -->
    <tr mat-footer-row *matFooterRowDef="['paginator']; sticky: true"></tr>
  </table>
</div>
